Index: IMGUI/imgui.cpp
===================================================================
--- IMGUI/imgui.cpp	(revision c58ebc3899e898504313cf42b9c1c05170b13f8f)
+++ IMGUI/imgui.cpp	(revision e66fd66b98dfb2d3f0f1af0833f4b2957f60d166)
@@ -3687,200 +3978,75 @@
 void ImGui::Shutdown(ImGuiContext* context)
 {
-   ImGuiContext& g = *context;
-
-   // The fonts atlas can be used prior to calling NewFrame(), so we clear it even if g.Initialized is FALSE (which would happen if we never called NewFrame)
-   if (g.IO.Fonts && g.FontAtlasOwnedByContext)
-      IM_DELETE(g.IO.Fonts);
-   g.IO.Fonts = NULL;
-
-   // Cleanup of other data are conditional on actually having initialize ImGui.
-   if (!g.Initialized)
-      return;
-
-   // Save settings (unless we haven't attempted to load them: CreateContext/DestroyContext without a call to NewFrame shouldn't save an empty file)
-   if (g.SettingsLoaded)
-      SaveIniSettingsToDisk(g.IO.IniFilename);
-
-   // Clear everything else
-   for (int i = 0; i < g.Windows.Size; i++)
-      IM_DELETE(g.Windows[i]);
-   g.Windows.clear();
-   g.WindowsSortBuffer.clear();
-   g.CurrentWindow = NULL;
-   g.CurrentWindowStack.clear();
-   g.WindowsById.Clear();
-   g.NavWindow = NULL;
-   g.HoveredWindow = NULL;
-   g.HoveredRootWindow = NULL;
-   g.ActiveIdWindow = NULL;
-   g.MovingWindow = NULL;
-   g.ColorModifiers.clear();
-   g.StyleModifiers.clear();
-   g.FontStack.clear();
-   g.OpenPopupStack.clear();
-   g.CurrentPopupStack.clear();
-   g.DrawDataBuilder.ClearFreeMemory();
-   g.OverlayDrawList.ClearFreeMemory();
-   g.PrivateClipboard.clear();
-   g.InputTextState.Text.clear();
-   g.InputTextState.InitialText.clear();
-   g.InputTextState.TempTextBuffer.clear();
-
-   for (int i = 0; i < g.SettingsWindows.Size; i++)
-      IM_DELETE(g.SettingsWindows[i].Name);
-   g.SettingsWindows.clear();
-   g.SettingsHandlers.clear();
-
-   if (g.LogFile && g.LogFile != stdout)
-   {
-      fclose(g.LogFile);
-      g.LogFile = NULL;
-   }
-   if (g.LogClipboard)
-      IM_DELETE(g.LogClipboard);
-   g.LogClipboard = NULL;
-
-   g.Initialized = false;
-}
-
-ImGuiWindowSettings* ImGui::FindWindowSettings(ImGuiID id)
-{
-   ImGuiContext& g = *GImGui;
-   for (int i = 0; i != g.SettingsWindows.Size; i++)
-      if (g.SettingsWindows[i].Id == id)
-         return &g.SettingsWindows[i];
-   return NULL;
-}
-
-static ImGuiWindowSettings* AddWindowSettings(const char* name)
-{
-   ImGuiContext& g = *GImGui;
-   g.SettingsWindows.push_back(ImGuiWindowSettings());
-   ImGuiWindowSettings* settings = &g.SettingsWindows.back();
-   settings->Name = ImStrdup(name);
-   settings->Id = ImHash(name, 0);
-   return settings;
-}
-
-static void LoadIniSettingsFromDisk(const char* ini_filename)
-{
-   if (!ini_filename)
-      return;
-   char* file_data = (char*)ImFileLoadToMemory(ini_filename, "rb", NULL, +1);
-   if (!file_data)
-      return;
-   LoadIniSettingsFromMemory(file_data);
-   ImGui::MemFree(file_data);
-}
-
-ImGuiSettingsHandler* ImGui::FindSettingsHandler(const char* type_name)
-{
-   ImGuiContext& g = *GImGui;
-   const ImGuiID type_hash = ImHash(type_name, 0, 0);
-   for (int handler_n = 0; handler_n < g.SettingsHandlers.Size; handler_n++)
-      if (g.SettingsHandlers[handler_n].TypeHash == type_hash)
-         return &g.SettingsHandlers[handler_n];
-   return NULL;
-}
-
-// Zero-tolerance, no error reporting, cheap .ini parsing
-static void LoadIniSettingsFromMemory(const char* buf_readonly)
-{
-   // For convenience and to make the code simpler, we'll write zero terminators inside the buffer. So let's create a writable copy.
-   char* buf = ImStrdup(buf_readonly);
-   char* buf_end = buf + strlen(buf);
-
-   ImGuiContext& g = *GImGui;
-   void* entry_data = NULL;
-   ImGuiSettingsHandler* entry_handler = NULL;
-
-   char* line_end = NULL;
-   for (char* line = buf; line < buf_end; line = line_end + 1)
-   {
-      // Skip new lines markers, then find end of the line
-      while (*line == '\n' || *line == '\r')
-         line++;
-      line_end = line;
-      while (line_end < buf_end && *line_end != '\n' && *line_end != '\r')
-         line_end++;
-      line_end[0] = 0;
-
-      if (line[0] == '[' && line_end > line && line_end[-1] == ']')
-      {
-         // Parse "[Type][Name]". Note that 'Name' can itself contains [] characters, which is acceptable with the current format and parsing code.
-         line_end[-1] = 0;
-         const char* name_end = line_end - 1;
-         const char* type_start = line + 1;
-         char* type_end = (char*)(intptr_t)ImStrchrRange(type_start, name_end, ']');
-         const char* name_start = type_end ? ImStrchrRange(type_end + 1, name_end, '[') : NULL;
-         if (!type_end || !name_start)
-         {
-            name_start = type_start; // Import legacy entries that have no type
-            type_start = "Window";
-         }
-         else
-         {
-            *type_end = 0; // Overwrite first ']' 
-            name_start++;  // Skip second '['
-         }
-         entry_handler = ImGui::FindSettingsHandler(type_start);
-         entry_data = entry_handler ? entry_handler->ReadOpenFn(&g, entry_handler, name_start) : NULL;
-      }
-      else if (entry_handler != NULL && entry_data != NULL)
-      {
-         // Let type handler parse the line
-         entry_handler->ReadLineFn(&g, entry_handler, entry_data, line);
-      }
-   }
-   ImGui::MemFree(buf);
-   g.SettingsLoaded = true;
-}
-
-static void SaveIniSettingsToDisk(const char* ini_filename)
-{
-   ImGuiContext& g = *GImGui;
-   g.SettingsDirtyTimer = 0.0f;
-   if (!ini_filename)
-      return;
-
-   ImVector<char> buf;
-   SaveIniSettingsToMemory(buf);
-
-   FILE* f = ImFileOpen(ini_filename, "wt");
-   if (!f)
-      return;
-   fwrite(buf.Data, sizeof(char), (size_t)buf.Size, f);
-   fclose(f);
-}
-
-static void SaveIniSettingsToMemory(ImVector<char>& out_buf)
-{
-   ImGuiContext& g = *GImGui;
-   g.SettingsDirtyTimer = 0.0f;
-
-   ImGuiTextBuffer buf;
-   for (int handler_n = 0; handler_n < g.SettingsHandlers.Size; handler_n++)
-   {
-      ImGuiSettingsHandler* handler = &g.SettingsHandlers[handler_n];
-      handler->WriteAllFn(&g, handler, &buf);
-   }
-
-   buf.Buf.pop_back(); // Remove extra zero-terminator used by ImGuiTextBuffer
-   out_buf.swap(buf.Buf);
-}
-
-void ImGui::MarkIniSettingsDirty()
-{
-   ImGuiContext& g = *GImGui;
-   if (g.SettingsDirtyTimer <= 0.0f)
-      g.SettingsDirtyTimer = g.IO.IniSavingRate;
-}
-
-static void MarkIniSettingsDirty(ImGuiWindow* window)
-{
-   ImGuiContext& g = *GImGui;
-   if (!(window->Flags & ImGuiWindowFlags_NoSavedSettings))
-      if (g.SettingsDirtyTimer <= 0.0f)
-         g.SettingsDirtyTimer = g.IO.IniSavingRate;
+    // The fonts atlas can be used prior to calling NewFrame(), so we clear it even if g.Initialized is FALSE (which would happen if we never called NewFrame)
+    ImGuiContext& g = *context;
+    if (g.IO.Fonts && g.FontAtlasOwnedByContext)
+    {
+        g.IO.Fonts->Locked = false;
+        IM_DELETE(g.IO.Fonts);
+    }
+    g.IO.Fonts = NULL;
+
+    // Cleanup of other data are conditional on actually having initialized Dear ImGui.
+    if (!g.Initialized)
+        return;
+
+    // Save settings (unless we haven't attempted to load them: CreateContext/DestroyContext without a call to NewFrame shouldn't save an empty file)
+    if (g.SettingsLoaded && g.IO.IniFilename != NULL)
+    {
+        ImGuiContext* backup_context = GImGui;
+        SetCurrentContext(context);
+        SaveIniSettingsToDisk(g.IO.IniFilename);
+        SetCurrentContext(backup_context);
+    }
+
+    // Notify hooked test engine, if any
+#ifdef IMGUI_ENABLE_TEST_ENGINE
+    ImGuiTestEngineHook_Shutdown(context);
+#endif
+
+    // Clear everything else
+    for (int i = 0; i < g.Windows.Size; i++)
+        IM_DELETE(g.Windows[i]);
+    g.Windows.clear();
+    g.WindowsFocusOrder.clear();
+    g.WindowsTempSortBuffer.clear();
+    g.CurrentWindow = NULL;
+    g.CurrentWindowStack.clear();
+    g.WindowsById.Clear();
+    g.NavWindow = NULL;
+    g.HoveredWindow = g.HoveredRootWindow = g.HoveredWindowUnderMovingWindow = NULL;
+    g.ActiveIdWindow = g.ActiveIdPreviousFrameWindow = NULL;
+    g.MovingWindow = NULL;
+    g.ColorModifiers.clear();
+    g.StyleModifiers.clear();
+    g.FontStack.clear();
+    g.OpenPopupStack.clear();
+    g.BeginPopupStack.clear();
+    g.DrawDataBuilder.ClearFreeMemory();
+    g.BackgroundDrawList._ClearFreeMemory();
+    g.ForegroundDrawList._ClearFreeMemory();
+
+    g.TabBars.Clear();
+    g.CurrentTabBarStack.clear();
+    g.ShrinkWidthBuffer.clear();
+
+    g.ClipboardHandlerData.clear();
+    g.MenusIdSubmittedThisFrame.clear();
+    g.InputTextState.ClearFreeMemory();
+
+    g.SettingsWindows.clear();
+    g.SettingsHandlers.clear();
+
+    if (g.LogFile)
+    {
+#ifndef IMGUI_DISABLE_TTY_FUNCTIONS
+        if (g.LogFile != stdout)
+#endif
+            ImFileClose(g.LogFile);
+        g.LogFile = NULL;
+    }
+    g.LogBuffer.clear();
+
+    g.Initialized = false;
 }
 
@@ -3888,128 +4054,140 @@
 static int IMGUI_CDECL ChildWindowComparer(const void* lhs, const void* rhs)
 {
-   const ImGuiWindow* const a = *(const ImGuiWindow* const *)lhs;
-   const ImGuiWindow* const b = *(const ImGuiWindow* const *)rhs;
-   if (int d = (a->Flags & ImGuiWindowFlags_Popup) - (b->Flags & ImGuiWindowFlags_Popup))
-      return d;
-   if (int d = (a->Flags & ImGuiWindowFlags_Tooltip) - (b->Flags & ImGuiWindowFlags_Tooltip))
-      return d;
-   return (a->BeginOrderWithinParent - b->BeginOrderWithinParent);
-}
-
-static void AddWindowToSortedBuffer(ImVector<ImGuiWindow*>* out_sorted_windows, ImGuiWindow* window)
-{
-   out_sorted_windows->push_back(window);
-   if (window->Active)
-   {
-      int count = window->DC.ChildWindows.Size;
-      if (count > 1)
-         qsort(window->DC.ChildWindows.begin(), (size_t)count, sizeof(ImGuiWindow*), ChildWindowComparer);
-      for (int i = 0; i < count; i++)
-      {
-         ImGuiWindow* child = window->DC.ChildWindows[i];
-         if (child->Active)
-            AddWindowToSortedBuffer(out_sorted_windows, child);
-      }
-   }
+    const ImGuiWindow* const a = *(const ImGuiWindow* const *)lhs;
+    const ImGuiWindow* const b = *(const ImGuiWindow* const *)rhs;
+    if (int d = (a->Flags & ImGuiWindowFlags_Popup) - (b->Flags & ImGuiWindowFlags_Popup))
+        return d;
+    if (int d = (a->Flags & ImGuiWindowFlags_Tooltip) - (b->Flags & ImGuiWindowFlags_Tooltip))
+        return d;
+    return (a->BeginOrderWithinParent - b->BeginOrderWithinParent);
+}
+
+static void AddWindowToSortBuffer(ImVector<ImGuiWindow*>* out_sorted_windows, ImGuiWindow* window)
+{
+    out_sorted_windows->push_back(window);
+    if (window->Active)
+    {
+        int count = window->DC.ChildWindows.Size;
+        if (count > 1)
+            ImQsort(window->DC.ChildWindows.Data, (size_t)count, sizeof(ImGuiWindow*), ChildWindowComparer);
+        for (int i = 0; i < count; i++)
+        {
+            ImGuiWindow* child = window->DC.ChildWindows[i];
+            if (child->Active)
+                AddWindowToSortBuffer(out_sorted_windows, child);
+        }
+    }
 }
 
 static void AddDrawListToDrawData(ImVector<ImDrawList*>* out_list, ImDrawList* draw_list)
 {
-   if (draw_list->CmdBuffer.empty())
-      return;
-
-   // Remove trailing command if unused
-   ImDrawCmd& last_cmd = draw_list->CmdBuffer.back();
-   if (last_cmd.ElemCount == 0 && last_cmd.UserCallback == NULL)
-   {
-      draw_list->CmdBuffer.pop_back();
-      if (draw_list->CmdBuffer.empty())
-         return;
-   }
-
-   // Draw list sanity check. Detect mismatch between PrimReserve() calls and incrementing _VtxCurrentIdx, _VtxWritePtr etc. May trigger for you if you are using PrimXXX functions incorrectly.
-   IM_ASSERT(draw_list->VtxBuffer.Size == 0 || draw_list->_VtxWritePtr == draw_list->VtxBuffer.Data + draw_list->VtxBuffer.Size);
-   IM_ASSERT(draw_list->IdxBuffer.Size == 0 || draw_list->_IdxWritePtr == draw_list->IdxBuffer.Data + draw_list->IdxBuffer.Size);
-   IM_ASSERT((int)draw_list->_VtxCurrentIdx == draw_list->VtxBuffer.Size);
-
-   // Check that draw_list doesn't use more vertices than indexable (default ImDrawIdx = unsigned short = 2 bytes = 64K vertices per ImDrawList = per window)
-   // If this assert triggers because you are drawing lots of stuff manually:
-   // A) Make sure you are coarse clipping, because ImDrawList let all your vertices pass. You can use the Metrics window to inspect draw list contents.
-   // B) If you need/want meshes with more than 64K vertices, uncomment the '#define ImDrawIdx unsigned int' line in imconfig.h to set the index size to 4 bytes. 
-   //    You'll need to handle the 4-bytes indices to your renderer. For example, the OpenGL example code detect index size at compile-time by doing:
-   //      glDrawElements(GL_TRIANGLES, (GLsizei)pcmd->ElemCount, sizeof(ImDrawIdx) == 2 ? GL_UNSIGNED_SHORT : GL_UNSIGNED_INT, idx_buffer_offset);
-   //    Your own engine or render API may use different parameters or function calls to specify index sizes. 2 and 4 bytes indices are generally supported by most API.
-   // C) If for some reason you cannot use 4 bytes indices or don't want to, a workaround is to call BeginChild()/EndChild() before reaching the 64K limit to split your draw commands in multiple draw lists.
-   if (sizeof(ImDrawIdx) == 2)
-      IM_ASSERT(draw_list->_VtxCurrentIdx < (1 << 16) && "Too many vertices in ImDrawList using 16-bit indices. Read comment above");
-
-   out_list->push_back(draw_list);
+    // Remove trailing command if unused.
+    // Technically we could return directly instead of popping, but this make things looks neat in Metrics window as well.
+    draw_list->_PopUnusedDrawCmd();
+    if (draw_list->CmdBuffer.Size == 0)
+        return;
+
+    // Draw list sanity check. Detect mismatch between PrimReserve() calls and incrementing _VtxCurrentIdx, _VtxWritePtr etc.
+    // May trigger for you if you are using PrimXXX functions incorrectly.
+    IM_ASSERT(draw_list->VtxBuffer.Size == 0 || draw_list->_VtxWritePtr == draw_list->VtxBuffer.Data + draw_list->VtxBuffer.Size);
+    IM_ASSERT(draw_list->IdxBuffer.Size == 0 || draw_list->_IdxWritePtr == draw_list->IdxBuffer.Data + draw_list->IdxBuffer.Size);
+    if (!(draw_list->Flags & ImDrawListFlags_AllowVtxOffset))
+        IM_ASSERT((int)draw_list->_VtxCurrentIdx == draw_list->VtxBuffer.Size);
+
+    // Check that draw_list doesn't use more vertices than indexable (default ImDrawIdx = unsigned short = 2 bytes = 64K vertices per ImDrawList = per window)
+    // If this assert triggers because you are drawing lots of stuff manually:
+    // - First, make sure you are coarse clipping yourself and not trying to draw many things outside visible bounds.
+    //   Be mindful that the ImDrawList API doesn't filter vertices. Use the Metrics window to inspect draw list contents.
+    // - If you want large meshes with more than 64K vertices, you can either:
+    //   (A) Handle the ImDrawCmd::VtxOffset value in your renderer back-end, and set 'io.BackendFlags |= ImGuiBackendFlags_RendererHasVtxOffset'.
+    //       Most example back-ends already support this from 1.71. Pre-1.71 back-ends won't.
+    //       Some graphics API such as GL ES 1/2 don't have a way to offset the starting vertex so it is not supported for them.
+    //   (B) Or handle 32-bit indices in your renderer back-end, and uncomment '#define ImDrawIdx unsigned int' line in imconfig.h.
+    //       Most example back-ends already support this. For example, the OpenGL example code detect index size at compile-time:
+    //         glDrawElements(GL_TRIANGLES, (GLsizei)pcmd->ElemCount, sizeof(ImDrawIdx) == 2 ? GL_UNSIGNED_SHORT : GL_UNSIGNED_INT, idx_buffer_offset);
+    //       Your own engine or render API may use different parameters or function calls to specify index sizes.
+    //       2 and 4 bytes indices are generally supported by most graphics API.
+    // - If for some reason neither of those solutions works for you, a workaround is to call BeginChild()/EndChild() before reaching
+    //   the 64K limit to split your draw commands in multiple draw lists.
+    if (sizeof(ImDrawIdx) == 2)
+        IM_ASSERT(draw_list->_VtxCurrentIdx < (1 << 16) && "Too many vertices in ImDrawList using 16-bit indices. Read comment above");
+
+    out_list->push_back(draw_list);
 }
 
 static void AddWindowToDrawData(ImVector<ImDrawList*>* out_render_list, ImGuiWindow* window)
 {
-   AddDrawListToDrawData(out_render_list, window->DrawList);
-   for (int i = 0; i < window->DC.ChildWindows.Size; i++)
-   {
-      ImGuiWindow* child = window->DC.ChildWindows[i];
-      if (child->Active && child->HiddenFrames == 0) // clipped children may have been marked not active
-         AddWindowToDrawData(out_render_list, child);
-   }
-}
-
-static void AddWindowToDrawDataSelectLayer(ImGuiWindow* window)
-{
-   ImGuiContext& g = *GImGui;
-   g.IO.MetricsActiveWindows++;
-   if (window->Flags & ImGuiWindowFlags_Tooltip)
-      AddWindowToDrawData(&g.DrawDataBuilder.Layers[1], window);
-   else
-      AddWindowToDrawData(&g.DrawDataBuilder.Layers[0], window);
+    ImGuiContext& g = *GImGui;
+    g.IO.MetricsRenderWindows++;
+    AddDrawListToDrawData(out_render_list, window->DrawList);
+    for (int i = 0; i < window->DC.ChildWindows.Size; i++)
+    {
+        ImGuiWindow* child = window->DC.ChildWindows[i];
+        if (IsWindowActiveAndVisible(child)) // clipped children may have been marked not active
+            AddWindowToDrawData(out_render_list, child);
+    }
+}
+
+// Layer is locked for the root window, however child windows may use a different viewport (e.g. extruding menu)
+static void AddRootWindowToDrawData(ImGuiWindow* window)
+{
+    ImGuiContext& g = *GImGui;
+    int layer = (window->Flags & ImGuiWindowFlags_Tooltip) ? 1 : 0;
+    AddWindowToDrawData(&g.DrawDataBuilder.Layers[layer], window);
 }
 
 void ImDrawDataBuilder::FlattenIntoSingleLayer()
 {
-   int n = Layers[0].Size;
-   int size = n;
-   for (int i = 1; i < IM_ARRAYSIZE(Layers); i++)
-      size += Layers[i].Size;
-   Layers[0].resize(size);
-   for (int layer_n = 1; layer_n < IM_ARRAYSIZE(Layers); layer_n++)
-   {
-      ImVector<ImDrawList*>& layer = Layers[layer_n];
-      if (layer.empty())
-         continue;
-      memcpy(&Layers[0][n], &layer[0], layer.Size * sizeof(ImDrawList*));
-      n += layer.Size;
-      layer.resize(0);
-   }
-}
-
-static void SetupDrawData(ImVector<ImDrawList*>* draw_lists, ImDrawData* out_draw_data)
-{
-   out_draw_data->Valid = true;
-   out_draw_data->CmdLists = (draw_lists->Size > 0) ? draw_lists->Data : NULL;
-   out_draw_data->CmdListsCount = draw_lists->Size;
-   out_draw_data->TotalVtxCount = out_draw_data->TotalIdxCount = 0;
-   for (int n = 0; n < draw_lists->Size; n++)
-   {
-      out_draw_data->TotalVtxCount += draw_lists->Data[n]->VtxBuffer.Size;
-      out_draw_data->TotalIdxCount += draw_lists->Data[n]->IdxBuffer.Size;
-   }
-}
-
-// When using this function it is sane to ensure that float are perfectly rounded to integer values, to that e.g. (int)(max.x-min.x) in user's render produce correct result.
+    int n = Layers[0].Size;
+    int size = n;
+    for (int i = 1; i < IM_ARRAYSIZE(Layers); i++)
+        size += Layers[i].Size;
+    Layers[0].resize(size);
+    for (int layer_n = 1; layer_n < IM_ARRAYSIZE(Layers); layer_n++)
+    {
+        ImVector<ImDrawList*>& layer = Layers[layer_n];
+        if (layer.empty())
+            continue;
+        memcpy(&Layers[0][n], &layer[0], layer.Size * sizeof(ImDrawList*));
+        n += layer.Size;
+        layer.resize(0);
+    }
+}
+
+static void SetupDrawData(ImVector<ImDrawList*>* draw_lists, ImDrawData* draw_data)
+{
+    ImGuiIO& io = ImGui::GetIO();
+    draw_data->Valid = true;
+    draw_data->CmdLists = (draw_lists->Size > 0) ? draw_lists->Data : NULL;
+    draw_data->CmdListsCount = draw_lists->Size;
+    draw_data->TotalVtxCount = draw_data->TotalIdxCount = 0;
+    draw_data->DisplayPos = ImVec2(0.0f, 0.0f);
+    draw_data->DisplaySize = io.DisplaySize;
+    draw_data->FramebufferScale = io.DisplayFramebufferScale;
+    for (int n = 0; n < draw_lists->Size; n++)
+    {
+        draw_data->TotalVtxCount += draw_lists->Data[n]->VtxBuffer.Size;
+        draw_data->TotalIdxCount += draw_lists->Data[n]->IdxBuffer.Size;
+    }
+}
+
+// Push a clipping rectangle for both ImGui logic (hit-testing etc.) and low-level ImDrawList rendering.
+// - When using this function it is sane to ensure that float are perfectly rounded to integer values,
+//   so that e.g. (int)(max.x-min.x) in user's render produce correct result.
+// - If the code here changes, may need to update code of functions like NextColumn() and PushColumnClipRect():
+//   some frequently called functions which to modify both channels and clipping simultaneously tend to use the
+//   more specialized SetWindowClipRectBeforeSetChannel() to avoid extraneous updates of underlying ImDrawCmds.
 void ImGui::PushClipRect(const ImVec2& clip_rect_min, const ImVec2& clip_rect_max, bool intersect_with_current_clip_rect)
 {
-   ImGuiWindow* window = GetCurrentWindow();
-   window->DrawList->PushClipRect(clip_rect_min, clip_rect_max, intersect_with_current_clip_rect);
-   window->ClipRect = window->DrawList->_ClipRectStack.back();
+    ImGuiWindow* window = GetCurrentWindow();
+    window->DrawList->PushClipRect(clip_rect_min, clip_rect_max, intersect_with_current_clip_rect);
+    window->ClipRect = window->DrawList->_ClipRectStack.back();
 }
 
 void ImGui::PopClipRect()
 {
-   ImGuiWindow* window = GetCurrentWindow();
-   window->DrawList->PopClipRect();
-   window->ClipRect = window->DrawList->_ClipRectStack.back();
+    ImGuiWindow* window = GetCurrentWindow();
+    window->DrawList->PopClipRect();
+    window->ClipRect = window->DrawList->_ClipRectStack.back();
 }
 
